
$Title TZ CGE Model: Impact of AGOA Policy
$ONTEXT
This model was developed to assess the potential impact of U.S.'s
African Growth Opportunity Act (AGOA) on Tanzania. The study was
sponsored  by USAID through Strategies and Analysis for Growth and
Access (SAGA) Project, administered by Clark Atlanta University and
Cornell University. The study was conducted by Dr. Aloyce R. Kaliba at
the University of Arkansasat Pine Bluff, U.S., in collaboration with
Ms Ummy A. Mwalimu and Mr. G. Kabelwa at the Economic and Social Research
Foundation, Tanzania. The analysis uses CGE_MPSGE model based on the 2001
Tanzania SAM. The Focus of the study is on examinaing the impact of
increase on cotton production, and textile and apparrel export on
poverty alleviation in Tanzania.
$offtext
option limcol=0, limrow=0, decimals=0 ;

set     i   SAM rows and column indices   /1*124/,
        s   List of activities and commodities/
                MAIZE  Growing of maize,
                PADDY  Growing of paddy,
                SORGH  Growing of sorghum and millet,
                WHEAT  Growing of wheat,
                BEANS  Growing of beans,
                CASSA  Growing of cassave,
                CEREA  Growing of other cereals,
                OILSE  Growing of oil seeds,
                ROOTS  Growing of other roots and tubers,
                COTTO  Growing of cotton,
                COFFE  Growing of coffee,
                TOBAC  Growing of Tobaco,
                TEAGR  Growing of tea,
                CASHE  Growing of cashew nuts,
                SISAL  Growing of sisal fiber,
                SUGAR  Growing of sugar cane ,
                OFRVE  Growing of fruits and vegetables,
                OCROP  Growing of other crops,
                LIVES  Operation of poultry and livestock,
                FISHI  Fishing and fish farms,
                HUFOR Hunting and forestry,
                MININ Mining and quarying,
                MEATD Processing of meat and dairy products,
                GRAIN Grain milling,
                PFOOD Processed food,
                BEVER Beverage and tobacco products,
                CLOTH Textile and leather products,
                WOODP Wood paper printing,
                CHEMI Manufacrure of basic and industrial chemicals,
                FERTI Manufacturer of fertilizer and pesticides,
                PETRO Petroleum refinaries,
                RUPLA Rubber plastic and other manufacturing,
                GLASS Glass and cement,
                METAL Iron steel and metal products,
                EQUIP Manufacture all equipment,
                UTILI Utilities,
                CONST Construction,
                TRADE Wholesale and retail trade'
                HOTEL Hotels and restaurant,
                TRANS Transport and communication,
                ESTAT Real estate,
                ADMIN Public administration health and education,
                PRIVS Business and other services /,
            M Margins /
                CTDTP-E Export transactions costs,
                CTDTP-D Domestic sales transactions costs,
                CTDTP-M Import transactions costs /,
          F Factors of production /
                FSUB    Subsistence factor,
                LCHILD  Child labor age 10 to 14,
                LNONF   Female laboe with no formal education,
                LNFPF   Female labor nonfinished primary school,
                LNFSF   Female labor nonfinished secondary school,
                LSECF   Female labor secondary or higher education,
                LNONM   Male laboe with no formal education,
                LNFPM   Male labor nonfinished primary school,
                LNFSM   Male labor nonfinished secondary school,
                LSECM   Male labor secondary or higher education,
                CAPAG   Agricultural capital,
                CAPNAG  Non-agricultural capital,
                LAND    Agricultural land /,
        E Enterprise Account  / ENTR / ,
        H Household Groups /
                HRBFPL  Rural below food poverty line,
                HRFBPL  Rural between basic needs poverty line,
                HRNOED  Rural nonpoor head with non education,
                HRNFPS  Rural nonpoor head not finished primary school,
                HRNFSS  Rural nonpoor head not finished secondary school,
                HRSECP  Rural nonpoor head finished secondary school,
                HUBFPL  Urban below food poverty line,
                HUFBPL  Urban between basic needs poverty line,
                HUNOED  Urban nonpoor head with non education,
                HUNFPS  Urban nonpoor head not finished primary school,
                HUNFSS  Urban nonpoor head not finished secondary school,
                HUSECP  Urban nonpoor head finished secondary school/ ,

        T Taxes /
                DIRTAX  Direct taxes on domestic products,
                IMPTAX  Import tariff,
                EXPTAX  Export taxes,
                VATAX   Value added or activity taxes,
                INDTAX  Indirect or sales taxes,
                FACTAX  Factor taxes /
alias  (i,j), (s,g,s1,s3,s2,s4), (m,mm);
* Mapping the activities
       Set mapa(i,s) Mapping from SAM to activities less cotton and textile /
                 1.MAIZE,
                 2.PADDY,
                 3.SORGH,
                 4.WHEAT,
                 5.BEANS,
                 6.CASSA,
                 7.CEREA,
                 8.OILSE,
                 9.ROOTS,
                 10.COTTO,
                 11.COFFE,
                 12.TOBAC,
                 13.TEAGR,
                 14.CASHE,
                 15.SISAL,
                 16.SUGAR,
                 17.OFRVE,
                 18.OCROP,
                 19.LIVES,
                 20.FISHI,
                 21.HUFOR,
                 22.MININ,
                 23.MEATD,
                 24.GRAIN,
                 25.PFOOD,
                 26.BEVER,
                 27.CLOTH,
                 28.WOODP,
                 29.CHEMI,
                 30.FERTI,
                 31.PETRO,
                 32.RUPLA,
                 33.GLASS,
                 34.METAL,
                 35.EQUIP,
                 36.UTILI,
                 37.CONST,
                 38.TRADE,
                 39.HOTEL,
                 40.TRANS,
                 41.ESTAT,
                 42.ADMIN,
                 43.PRIVS /,

         mapc(i,g)  mapping from SAM to commodities  less cotton and textile/
                 44.MAIZE,
                 45.PADDY,
                 46.SORGH,
                 47.WHEAT,
                 48.BEANS,
                 49.CASSA,
                 50.CEREA,
                 51.OILSE,
                 52.ROOTS,
                 53.COTTO,
                 54.COFFE,
                 55.TOBAC,
                 56.TEAGR,
                 57.CASHE,
                 58.SISAL,
                 59.SUGAR,
                 60.OFRVE,
                 61.OCROP,
                 62.LIVES,
                 63.FISHI,
                 64.HUFOR,
                 65.MININ,
                 66.MEATD,
                 67.GRAIN,
                 68.PFOOD,
                 69.BEVER,
                 70.CLOTH,
                 71.WOODP,
                 72.CHEMI,
                 73.FERTI,
                 74.PETRO,
                 75.RUPLA,
                 76.GLASS,
                 77.METAL,
                 78.EQUIP,
                 79.UTILI,
                 80.CONST,
                 81.TRADE,
                 82.HOTEL,
                 83.TRANS,
                 84.ESTAT,
                 85.ADMIN,
                 86.PRIVS  /,

           mapm(i,m) mapping from SAM to marketing margins /
                 87.CTDTP-E,
                 88.CTDTP-D,
                 89.CTDTP-M /,

          mapf(i,f) mapping from SAM to factors of production /
                 90.FSUB,
                 91.LCHILD,
                 92.LNONF,
                 93.LNFPF,
                 94.LNFSF,
                 95.LSECF,
                 96.LNONM,
                 97.LNFPM,
                 98.LNFSM,
                 99.LSECM,
                 100.CAPAG,
                 101.CAPNAG,
                 102.LAND /,
           mape(i,e) mapping from SAM to enterprise account  /103.ENTR /,
           maph(i,h) mapping from SAM to household groups/
                 104.HRBFPL,
                 105.HRFBPL,
                 106.HRNOED,
                 107.HRNFPS,
                 108.HRNFSS,
                 109.HRSECP,
                 110.HUBFPL,
                 111.HUFBPL,
                 112.HUNOED,
                 113.HUNFPS,
                 114.HUNFSS,
                 115.HUSECP  /,

            mapg(i) identifying government row /116 /,
            mapt(i,t) mapping from SAM to source of taxes /
                 117.DIRTAX,
                 118.IMPTAX,
                 119.EXPTAX,
                 120.VATAX,
                 121.INDTAX,
                 122.FACTAX  /,
            mapx(i) identifing the rest of the world /123 /,
            mapi(i) identifying the investment and saving row/124/;

Table sam(i,j)  Base year social accounts
$include c:\tzcge\TZSAM2001.inc
*display sam;

* Chech if sum of rows equal sum of columns

parameter       chksam(i)       Consistency check of social accounts;
chksam(i) = sum(j, sam(i,j)-sam(j,i));
*display "Consistency check before balancing:", chksam;

*Balance the SAM using least squares

variable        obj             Objective -- least squares deviation;

positive
variable        es(i,j)                Estimate of SAM entries;

equations       objdef          Defines the deviation
                balance(i)      SAM balance condition;

scalar  penalty  /1e6/;

objdef..        obj =e=   sum((i,j), sqr(es(i,j)-sam(i,j)))
                        + sum((i,j)$(not sam(i,j)), penalty * es(i,j));

balance(i)..    sum(j, es(i,j)) =e= sum(j, es(j,i));

es.l(i,j) = sam(i,j);

model TZSAM2001 /all/;
option solprint=off;
solve TZSAM2001 using NLP minimizing obj;

parameter       nz(i,j)        New nonzeros in the SAM;
nz(i,j) = es.l(i,j)$(not sam(i,j));

*display nz;

sam(i,j) = es.l(i,j);
chksam(i) = sum(j, sam(i,j)-sam(j,i));
*display "Consistency check after balancing:", chksam;
*  Extract the required submatrices from the social accounts:


parameter       CA(g,s)        Intermediate inputs demand
                FA(f,s)        Factor demand or value added
                TA(t,s)        Non tax collection
                AC(s,g)        Marketed output
                MC(m,g)        Marketing and transportation costs
                TC(t,g)        Indirect taxes
                RC(g)          Value of imports at (cif)
                CM(g,m)        Wholesale and retail cost
                HF(h,f)        Factor income to households
                EF(e,f)        Factor income to enterprise
                TF(T,F)        Factor taxes to government
                RF(f)          Factor remitance to rest of RoW
                HA(h,s)        Household consumption of own production
                HE(h,e)        Enterprise payment to households
                TE(t,E)        Enterprise direct taxes
                GE(e)          Enterprise divident payment to government
                GH(h)          Household divident payment to goverment
                GT(t)          Total taxes from households to government
                CG(g)          Government investment
                CG(s3)         Government investment to cotton production
                CG(s4)         Government investment to Textile and Leather
                HG(h)          Government transfer to households
                IG(i)          Government savings
                ER(g)          Export (fob)
                HR(h)          Household income from RoW
                SR(i)          Foreign savings or borrowing
                CS(g)          Total investiment spending or investment demand
                DS(s)          Domestic supply
                AS(g)          Aggregate supply
                TM(g)          Transportation cost rate for marketed goods
                RM(g)          Reference cost for marketed goods
                IT(g)          Import Tax rate
                IP(g)          Reference price of imports
                EP(g)          Reference tax of export
                CH(g,h)        Private consumption
                PS(h)          Private savings
                FAE(f,h)       Factor endowments
                GD(g)          Government Demand
                DP(f)          Depreciation
                TIV            Total Investment
                IVT            Investment tax
                ITR            Investment tax rate
                FFR(F)         Foreign factor return
                GSV            Government savings
                FSV            Foreign savings
                FTX(f)         Factor taxes
                MKM(m,g)       Marketing margins
                ITP(h)         Income tax payment by households;

Scalar          EXT            Export tax rate /0.0/;


loop((mapc(i,g), mapa(j,s)),         ca(g,s) = sam(i,j) );
loop((mapf(i,f), mapa(j,s)),         fa(f,s) = sam(i,j) );
loop((mapt(i,t), mapa(j,s)),         ta(t,s) = sam(i,j) );
loop((mapa(i,s), mapc(j,g)),         ac(s,g) = sam(i,j) );
loop((mapm(i,m), mapc(j,g)),         mc(m,g) = sam(i,j) );
loop((mapt(i,t), mapc(j,g)),         tc(t,g) = sam(i,j) );
loop((mapx(i),   mapc(j,g)),         rc(g) = sam(i,j) );
loop((mapc(i,g), mapm(j,m)),         cm(g,m) = sam(i,j) );
loop((maph(i,h), mapf(j,f)),         hf(h,f) = sam(i,j) );
loop((mape(i,e), mapf(j,f)),         ef(e,f) = sam(i,j) );
loop((maph(i,h), mape(j,e)),         he(h,e) = sam(i,j) );
loop((mapt(i,t), mape(j,e)),         te(t,e) = sam(i,j) );
loop((mapg(i),   mape(j,e)),         ge(e)   = sam(i,j) );
loop((mapt(i,t), mapf(j,f)),         tf(t,f) = sam(i,j) );
loop((mapx(i),   mapf(j,f)),         rf(f)   = sam(i,j) );
loop((maph(j,h), mapa(i,s)),         ha(h,s) = sam(i,j) );
loop((mapg(i),   maph(j,h)),         gh(h)   = sam(i,j) );
loop((mapg(i),   mapt(j,t)),         gt(t)   = sam(i,j) );
loop((mapc(i,g), mapg(j)),           cg(g)  = sam(i,j) );
loop((maph(i,h), mapg(j)),           hg(h)  = sam(i,j) );
loop((mapi(i) ,  mapg(j)),           IG(i)  = sam(i,j) );
loop((mapc(i,g), mapx(j)),           er(g)  = sam(i,j) );
loop((maph(i,h), mapx(j)),           hr(h)  = sam(i,j) );
loop((mapi(i),   mapx(j)),           SR(i)  = sam(i,j) );
loop((mapc(i,g), mapi(j)),           cs(g) = sam(i,j) );
loop((mapc(i,g), maph(j,h)),         ch(g,h) = sam(i,j) );
loop((mapi(i), maph(j,h)),           ps(h) = sam(i,j) );
loop((maph(i,h), mapf(j,f)),         fae(f,h) = sam(i,j) );
loop((mapc(i,g), mapg(j)),           gd(g) = sam(i,j) );
loop((mapi(i), mapf(j,f)),           dp(f) = sam(i,j) );
loop((mapx(i), mapf(j,f)),           ffr(f) = sam(i,j) );
loop((mapi(i), mapg(j)),             gsv = sam(i,j) );
loop((mapi(i), mapx(j)),             fsv = sam(i,j) );
loop((mapg(i), mapf(j,f)),           ftx(f) = sam(i,j) );
loop((mapm(i,m),mapc(j,g)),          mkm(m,g)=sam(i,j));
loop((mapg(i), mapi(j)),             ivt=sam(i,j));
loop((mapg(i), maph(j,h)),           itp(h)=sam(i,j));

*For uniform marketing marketing margins:note export tax is zero
TM(g)$(sum(s, ac(s,g))gt 0)=sum(m, mc(m,g))/sum(s, AC(s,g));
*Reference price for domestic supply
RM(g)=1-TM(g);
* Domestic supply is the sum of itermediate input, value added or factor
*demand, and home consumed output minus value of export;
DS(s)=sum(g,  ca(g,s))+   sum(f, fa(f,s))+sum(h, ha(h,s))-er(s)*rm(s);

*Reference price of imports:(import costs+marketing costs)/value of imports
IT(g)$(rc(g)>0)=(sum(t, TC(t,g))+sum(m, mc("ctdtp-m",g)))/RC(g);
IP(g) =1-IT(g);
IP(G)$(ip(g)<0)=0.0001;

*Aggregate supply is the sum of domestic supply and value of imports
AS(g)=ds(g)+rc(g)*ip(g);

* Total investment is the sum of investment tax and investment demand
tiv=ivt+sum(g,cs(g));

*Investment tax rate is the ratio of investment tax and total investment
itr=ivt/tiv;

*display ep,ds, as, ip;

*MSPGE modeling

$ontext

$model:AGOA

$sectors:
        y(s)       ! Sectoral output (domestic production)
        a(s)       ! Aggregate supply (Armington aggregate)
        c(h)       ! Household consumption
        invest     ! Aggregate investment

$commodities:
        pd(s)   ! Domestic output
        pa(s)   ! Composite demand price for marketed ouput
        pc(h)   ! Household consumption price
        pf(f)   ! Factor prices
        pinv    ! Investment
        pfx     ! Price of foreign exchange


$consumers:
        ra(h)   ! Private households
        govt    ! Government

$auxiliary:
        tau1    ! Private consumption constrait
        tau2    !

*Production for domestict market and for export:
$prod:y(s) s:1 t:4 va:1
           o:pfx     q:er(s)
           o:pd(s)   q:ds(s)  p:rm(s)
           i:pa(g)   q:ca(g,s)
           i:pf(f)   q:fa(f,s)    a:govt t:(sum(t,tf(t,f))) va:
$report:
        v:x(s) o:pfx  prod:y(s)

* Armington aggregation of domestic and imported goods:

$prod:a(s) s:2
           o:pa(s)   q:as(s)     p:rm(s)
           i:pd(s)   q:ds(s)     p:rm(s)
           i:pfx     q:rc(s)     p:ip(s)    a:govt t:it(s)

*$report:
*        v:m(s) i:pfx  prod:a(s)

* Investment:
$prod:invest
      o:pinv  q:tiv a:govt t:itr
      i:pa(g) q:cs(g)

*Total Household consumption equals sums of private and own produced goods:
$prod:c(h) s:1
      o:pc(h)  q:(sum(g,ch(g,h)))
      i:pa(g)  q:ch(g,h)

*Household demand with exogenously fixed investment, taxes and transfers:
$demand:ra(h)
        d:pc(h)
        e:pinv    q:(-ps(h))
        e:pc(h)   q:(hg(h)-itp(h))
        e:pf(f)   q:fae(f,h)

* Government demand for goods, transfers, investment, savings,factors ownership:
$demand:govt s:0
        d:pa(g)  q:gd(g)
        e:pc(h)  q:(itp(h)-hg(h))
        e:pinv   q:(-gsv-fsv-sum(f,dp(f)))
        e:pf(f)  q:(ftx(f)+dp(f)+ffr(f))
        e:pfx    q:(fsv-sum(f,ffr(f)))
$constraint:tau1
           sum(h, ra(h))=e=sum(h, sum(g, pc(h)*ch(g,h))+ sum(s, pc(h)*ha(h,s)));
$constraint:tau2
            govt=e=sum(g, pa(g)*gd(g));
$FUNLOG:.true
$PEPS:.1.0E-6
$offtext
option sysout=on;
$sysinclude mpsgeset AGOA
AGOA.iterlim=0;
AGOA.workspace=3.5;
$include AGOA.gen
PA.FX("MAIZE")=1;
solve AGOA using mcp;

*Simulation
*Decrease export transaction costs for cotton and textile by 50%:
AGOA.iterlim=500000;
*rm(g)$(er(g)>0)=(1-(sum(m, mc("ctdtp-e",g))/er(g)))*0.5;
rm(g)=0.5;
$include AGOA.gen
Solve AGOA using mcp;

*Generate reports:

Parameter EV     Hicksian equivalent variation in income (% change)
          Trade  Trade levels (% Change)
          THC(h) Total household consumption;

THC(h)=sum(g,ch(g,h))+sum(s, ha(h,s));
EV(h,"%C")=100*(C.l(h)-1);
EV(h,"%GDP")=100*(c.l(h)-1)*(THC(h)/(THC(h)+PS(h)));
EV("total","%C")=100*(sum(h,C.l(h)*THC(h))/sum(h,THC(h))-1);
EV("Total","GDP")=100*(sum(h,c.l(h)*THC(h))/sum(h, THC(h))-1)*sum(h,THC(h))/
                  sum(f, sum(h, FAE(f,h))+FTX(f)+DP(f));

TRADE(s, "export")$(er(s)>0)=100*(x.l(s)/ER(s)-1);

display THC, EV, TRADE, TAU1.L, TAU2.L;